

// 19-04-2008 COBA Systems  Stanojevi S.
****************
* _MENI_GUI.PRG *
****************


  #include "Appevent.ch"
  #include "Xbp.ch"
  #include "Box.ch"
  #include "common.ch"
  #include "Fileio.ch"

  #define MENUITEM_SEPARATOR  {NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0}



*********************************************************************
   PROCEDURE MENI  // MENU BAR ZA CRT|GUI XBASE++ APLIKACIJE
*********************************************************************
      LOCAL nEvent, mp1, mp2, oXbp
      LOCAL aItem

      PUBLIC oMenuBar, oMenu_Opcije, oMenu_Firma, oMenu_User, ;
             oMenu_Help, oMenu_Kraj

      Setcolor( "N/W")
      CLS


    HelpMake()

    // Allow use of shortcut keys
    SetAppWindow():useShortCuts := .T.

    // Install menu bar in the XbpCrt window
    oMenuBar := SetAppWindow():MenuBar()


    oMenu_Opcije       := XbpMenu():new(oMenuBar):create()
    oMenu_Opcije:title := "Opcije"
    oMenu_Opcije:addItem( { "Gde se arhiviraju podaci" ,  {||NIL} } )
    oMenu_Opcije:addItem( { "ime se pregledaju podaci",  {||NIL} } )
    oMenuBar:addItem( { oMenu_Opcije, NIL } )

    oMenu_Firma       := XbpMenu():new(oMenuBar):create()
    oMenu_Firma:title := "Firma"
    oMenu_Firma:addItem( { "Oznake firme klijenta programa" , {||NIL}} )
    oMenu_Firma:addItem( { "Lokacija Baze podataka programa", {||NIL}} )
    oMenuBar:addItem( { oMenu_Firma, NIL } )

    oMenu_User       := XbpMenu():new(oMenuBar):create()
    oMenu_User:title := "Ovlaenja"
    oMenu_User:addItem( { "Administracija" ,  {|| NIL  }}) // ovde na kraju
    oMenuBar:addItem( { oMenu_User, NIL } )

    oMenu_R       := XbpMenu():new(oMenuBar):create()
    oMenu_R:title := "Rekonstrukcija "
    oMenu_R:addItem( { "Rekonstrukcija ",      {||  nil }})
    oMenu_R:addItem( MENUITEM_SEPARATOR )
    oMenu_R:addItem( { "Odravanje podataka",   {||  nil  }})
    oMenu_R:addItem( { "Arhiiranje podataka",   {||  nil  }})
    oMenu_R:addItem( { "Podeavanje programa",  {||  nil  }})
    oMenuBar:addItem( { oMenu_R, NIL } )

    oMenu_Help       := XbpMenu():new(oMenuBar):create()
    oMenu_Help:Title := "Help"
    oMenu_Help:addItem( { "Generalni Help"    ,   {|| HelpShow("PROGRAM.HTM") }})
    oMenu_Help:addItem( { "Knjiga programa"   ,   {|| nil }})
    oMenu_Help:addItem( MENUITEM_SEPARATOR )
    oMenu_Help:addItem( { "Program"          ,   {|| _program("COBA Systems ") }})
    oMenu_Help:addItem( { "Autor"            ,   {|| _autor() }})
    oMenu_Help:addItem( MENUITEM_SEPARATOR )
    oMenu_Help:addItem( { "Licenca "         ,   {|| _licenca() }})
    oMenu_Help:addItem( { "Registrovanje "   ,   {|| nil }})
    oMenuBar:addItem( { oMenu_Help, NIL } )

    oMenu_Kraj       := XbpMenu():new(oMenuBar):create()
    oMenu_Kraj:title := "   ~Kraj   "
    oMenu_Kraj:addItem( { "~KRAJ", } )
    oMenu_Kraj:itemSelected := {|mp1| MyMenuProcedure( 401 )  }
    oMenuBar:addItem( { oMenu_Kraj, NIL } )


      PostAppEvent( xbeP_Close )
      // Event loop
       nEvent := 0
      DO WHILE nEvent <> xbeP_Close
         nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDDO
   RETURN

 ********************************************************************************
   PROCEDURE MyMenuProcedure( nMenuSelection )
 ********************************************************************************
   SET COLOR TO /W
   MENI_OF()
      DO CASE
      CASE nMenuSelection == 401
           // The user will terminate
           * PostAppEvent( xbeP_Close )
           CLOSE DATABASES
           CLOSE ALL
             QUIT
      ENDCASE
        MAIN1()    // glavni izbor rada i ukljucivanje ikone
        MENI_ON()  // mora i NA POCETKU MAIN1()
  RETURN

 ********************************************************************************
 PROCEDURE MENI_OF()
 ********************************************************************************
   oMenuBar:disable()
 RETURN
 ********************************************************************************
 PROCEDURE MENI_ON()
 ********************************************************************************
   oMenuBar:enable()
 RETURN





*******************************************************
STATIC FUNCTION HelpMake()  // HTML XbpHelp sistem
*******************************************************
/*
  U Main() proceduri postavi se komanda
            HelpMake()
  U meniju postavi se komanda
        HelpShow("PROGRAM.HTM")
  ili skok na Bookmark
        HelpShow("PROGRAM.HTM#Uvod")
*/

   // kreiranje CHM HELP objekta:
    PUBLIC HtmlFajl   := "PROGRAM.CHM"
    PUBLIC oXbpHelp

    oXbpHelp := XbpHelp():New( , HtmlFajl, "Help" )
    oXbpHelp:Create()

RETURN(nil)


*******************************************************
FUNCTION HelpShow(naslov)  // HTML XbpHelp sistem
*******************************************************

 IF oXbpHelp:ShowHelp( naslov ) == .F.

    MsgBox ( HtmlFajl, "Nema CHM fajla:" )

 ENDIF

RETURN(nil)
