
* _SPISAK_FAJLOVA.PRG
// 20-04-2008 COBA Systems  Stanojevi S.




#include "common.ch"
#include "Directry.ch"
*************************************************************************************
FUNCTION Spisak_Fajlova(cMaska,Target_Folder,uredi) // --> aFile
//spisak fajlova *.* iz zadatog foldera
*************************************************************************************
// cMaska  := "*.EXE"
// Target_Folder := "D:\programi\izvorni kod"  -  mora da bude pun PATH
// uredi = "naziv", uredi = "datum", uredi = "size"
// Vraa niz aFile, koji je dobijen komandom DIRECTORY(),
// i formira C:\t.txt u kome je spisak fajlova ureen po nazivu, datumu, veliini

LOCAL dDatum, cDatum,;
      aFiles, nBroj, nSuma, i, nn, nIme, ;
      Source_Drajv, Source_Folder,;
      Target_Drajv, cTxt := "t.txt"
      DELETE FILE (cTxt)

DEFAULT cMaska TO "*.*", ;
        Target_Folder TO CurDrive()+":\"+CurDir(),;  // PUN PATH
        uredi TO "naziv"

SET DATE GERMAN
SET CENTURY ON

      IF FILE(Target_Folder,"D")=.F.
         MsgBox(Target_Folder,"Ne postoji lokacija:")
         RETURN(nil)
      ENDIF


      Source_Drajv  := CurDrive()
      Source_Folder := CurDrive()+":\"+CurDir()   // PUN PATH
      Target_Drajv  := SUBSTR(Target_Folder,1,1)


         CurDrive(Target_Drajv)        // menjaj drajv
         CurDir(Target_Folder)         // menjaj folder - mora pun PATH !!!

           aFiles := Directory(cMaska)
           nBroj  := LEN(aFiles)

         CurDrive(Source_Drajv)        // vrati na polazni drajv
         CurDir(Source_Folder)         // vrati na polazni folder - mora pun PATH !!!

/*
  directory.ch
  Constant         Contents                data type

  F_NAME           file name               C
  F_SIZE           size of the file        N
  F_WRITE_DATE     date of last update     D
  F_DATE     *)    compatibility constant
  F_WRITE_TIME     time of last update     C
  F_TIME     *)    compatibility constant
  F_ATTR           file attribute          C
  F_EA_SIZE        size of the extended    N
                   file attributes
  F_CREATION_DATE  date of creation        D
  F_CREATION_TIME  time of creation        C
  F_ACCESS_DATE    date of last opening    D
  F_ACCESS_TIME    time of last opening    C
*/

      nIme := 0   // broj karaktera najdueg imena fajla
      FOR i=1 TO nBroj
          nn := LEN( aFiles[i, F_NAME] ) // duina imena fajla u karakterima
          IF nn>nIme
             nIme := nn
          ENDIF
      NEXT i



      IF uredi = "naziv"
      // sort array by file name
       ASort( aFiles,,, {|a1,a2| a1[ F_NAME ] < a2[ F_NAME ] } )
      ENDIF
      IF uredi = "datum"
      // sort array by file name
      ASort( aFiles,,, {|a1,a2| a1[ F_WRITE_DATE ] > a2[ F_WRITE_DATE ] } )
      ENDIF

      IF uredi = "size"
      // sort array by file name
      ASort( aFiles,,, {|a1,a2| a1[ F_SIZE ] > a2[ F_SIZE ] } )
      ENDIF


      // divert print output to file
      SET CONSOLE OFF
      SET PRINTER TO (cTxt)
      SET PRINTER ON
      ? "  Folder: "+Target_Folder
      ? "  Ukupno: "+alltrim(str(nBroj))
      ?

      nSuma := 0
      FOR i=1 TO nBroj

          ? "  " +PadR( aFiles[i, F_NAME], nIme ) + " " + ;
                  DTOC( aFiles[i, F_WRITE_DATE])  + " " + ;
                  STR(  aFiles[i, F_SIZE]/1000/1000 ) // + " MB"

          nSuma = nSuma + ( aFiles[i, F_SIZE]/1000/1000 )

      NEXT i
          ? " "
          ? "  Svega:" + STR(nSuma) + " MB"


      SET PRINTER TO
      SET PRINTER OFF
      SET CONSOLE ON

      // pozovi posle izvrenja ove funkcije:
      // q := RunShell("t.txt","NOTEPAD.EXE")

RETURN(aFiles)
