
* _ZADAJ_TEKST.PRG

  /*
    20-04-2008 COBA Systems  Stanojevi S.


    Alaska
    GUI Dialog Box za upis teksta, koji vraa upisanu vrednost

    Clipper
    CRT Dialog Box za upis teksta, numerika, datuma, koji vraa upisanu vrednost

  */


  #include "Box.ch"
  #include "Fileio.ch"
  #include "Appevent.ch"
  #include "Xbp.ch"
  #include "Gra.ch"
  #include "Font.ch"
  #include "color.ch"
  #include "common.ch"
  #include "inkey.ch"
  #include "set.ch"
  #include "Directry.ch"


*************************************************************************************
 FUNCTION c_zadaj(cNaslov,cUpis,nDuzina,lSakrij) //--> cUpis  GET upis jednog polja

/*
  XBase++ cod
  Upis jednog STRING podatka u GET box
  cUpis - string koji treba potvrditi ili upisati novi umesto njega
  cNaslov - naslov u TitleBar-u dialoga
  nDuzina - broj znakova koji se moze upisati u polje za upis
  lSakrij - ako je .T. znakovi u polju za upis su zamenjeni sa "*"
  Izlaz sa Esc, Enter, ili na dugme [OK]
  vraca NOVI upisani string ili neizmenjeni PRIMLJENI string cUpis

*/
*************************************************************************************
   LOCAL nEvent, mp1, mp2, oXbp, lExit
   LOCAL oDlg, oID, drawingArea
   Local xUpis, RetUpis

   DEFAULT cUpis TO "", cNaslov TO "  Zadaj:", nDuzina TO 25, lSakrij TO .F.
   SET CHARSET TO ANSI
   cUpis := ALLTRIM(cUpis)


   aSize            := {220,80}
   aPos             := CenterPos( aSize, AppDesktop():currentSize() )

   // Parent is desktop, owner is application window
   oDlg             := XbpDialog():new( AppDesktop(),SetAppWindow(), aPos, aSize, , .F.)
   oDlg:border      := XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:title       := cNaslov
   oDlg:sysMenu     := .T.
   oDlg:maxButton   := .F.
   oDlg:minButton   := .F.
   oDlg:visible     := .F.
   oDlg:close       :=  {|| PostAppEvent( xbeP_Close ) }
   oDlg:create()

   drawingArea      := oDlg:drawingArea
   drawingArea:setFontCompoundName( FONT_HELV_SMALL + FONT_STYLE_BOLD )

   oID              := XbpSLE():new( drawingArea, , {2,30}, {208,22} )
   oID:group        := XBP_BEGIN_GROUP
   oID:tabStop      := .T.
   oID:bufferLength := nDuzina
   oID:editable     := .T.
   oID:unreadable   := lSakrij
   oID:border       := .T.
   oID:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC .OR. nKey == xbeK_RETURN, ;
                                          lExit := .T., NIL ) }
   oID:create()
   oID:SetData(cUpis)
   //oID:SetData("")
   oID:setFontCompoundName( FONT_COURIER_MEDIUM + FONT_STYLE_BOLD )

   oXbp             := XbpPushButton():new( drawingArea, , {2,2}, {67,62})
   oXbp:group       := XBP_END_GROUP
   oXbp:caption     := " OK "
   oXbp:tabStop     := .T.
   oXbp:preselect   := .T. // daje mu 3d dimenziju
   oXbp:autosize    := .T.
   oXbp:activate    := {|| lExit := .T. }
   oXbp:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC .OR. nKey == xbeK_RETURN, ;
                                     PostAppEvent( xbeP_Activate,,, obj ), NIL ) }
   oXbp:create()
   oXbp:setpointer(nil,2)

   oDlg:show()
   oDlg:setModalState( XBP_DISP_APPMODAL )
    // This makes the login window modal
    SetAppFocus( oID )
   lExit := .F.
   DO WHILE ! lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
   RetUpis   := AllTrim( oID:getData()  )

   oDlg:setModalState( XBP_DISP_MODELESS )
   oDlg:destroy()
   // Clean up event queue
    CLEAR TYPEAHEAD
RETURN(RetUpis)




// CenterPos( aSize, aRefSize )
// Standardna Xbase++ funkcija za centriranje prozora
// sa dimenzijama na primer: aSize := {300,400}
// u drugom prozoru na primer: oParent := AppDesktop()
// aPos := CenterPos( aSize, oParent:currentSize() )
// gde je aPos := {x,y} pozicija pocetka prozora
***********************************************
STATIC FUNCTION CenterPos( aSize, aRefSize )
***********************************************
RETURN { Int( (aRefSize[1] - aSize[1]) / 2 ) ;
       , Int( (aRefSize[2] - aSize[2]) / 2 ) }







*****************************************************************************
FUNCTION ZADAJ
*****************************************************************************
/*

  Clipper 87' kod


*/


set date german
SET CENTURY ON

PARAMETERS ftekst,fbroj,ftip
PRIVATE ftekst,fbroj,ftip,fprozor,duzina1,y1,y2,upis,fboja,fpik
*
* sintaksa
* upis = ZADAJ("Upisi sifru robe koju hoces da nadjes -> ",5,"N")
* 5=broj mesta za upis
* N=tip podatka (N=Numerik, S=string, D=datum)
*
fboja=setcolor()
save screen to fprozor
duzina1=len(ftekst)+1+fbroj
y1 = 40-(duzina1/2)
y2 = y1+len(ftekst)+1

set color to W+/B,W+/B
@ 10,y1-2 clear to 14,y2+fbroj+2
@ 10,y1-2,14,y2+fbroj+2 BOX '͸Գ'
set color to W+*/B,W+/B
@ 12,y2+fbroj+1 say ""
set color to W+/B,W+/B
tone(3000,1)
@ 12,y1 say ftekst
SET CURSOR ON

if ftip="D"
upis=ctod("  .  .    ")
@ 12,y2 get upis
read
clear gets


elseif ftip="N"
upis=0
fpik=replicate("9",fbroj)
@ 12,y2 get upis picture fpik
read
clear gets


else
upis=space(fbroj)
@ 12,y2 get upis pict "@X"
read
clear gets

endif


SET CURSOR OFF
set color to
setcolor(fboja)

restore screen from fprozor
release fprozor
RETURN upis





